﻿using C1.WPF;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;


namespace TreeViewTest
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : System.Windows.Window
    {

        public MainWindow()
        {
            InitializeComponent();
           
            //UC with Treeview inside ElementHost
            var userControlElementHostChild  = new UserControl1();
            userControlElementHostChild.Loaded += UserControlElementHostChild_Loaded;
            Form form = new Form();
            form.Height = 400;
            form.Width = 600;
            form.Text = "C1Treeview as ElementHost Child";
            System.Windows.Forms.Integration.ElementHost eh = new System.Windows.Forms.Integration.ElementHost();
            eh.Dock = DockStyle.Fill;
            eh.Child = userControlElementHostChild;
            form.Controls.Add(eh);
            form.Show();

            //UC in WPF App
            var userControlWPFWindowContent = new UserControl1();
            this.Content = userControlWPFWindowContent;
        }

        private void UserControlElementHostChild_Loaded(object sender, RoutedEventArgs e)
        {
            var treeView = FindControl<C1TreeView>(sender as UserControl1, typeof(C1TreeView), "treeView");
            //var treeView = ((sender as UserControl1).Content as Grid).Children[0] as C1TreeView;
            foreach(C1TreeViewItem item in treeView.Items)
            {
                SetTextAlignment(item);
            }
            
        }

        public void SetTextAlignment(C1TreeViewItem treeViewItem)
        {
            var temp = FindControl<ContentControl>(treeViewItem as C1TreeViewItem, typeof(ContentControl), "Header");
            temp.VerticalAlignment = VerticalAlignment.Center;

            foreach (C1TreeViewItem item in treeViewItem.Items)
            {
                //recursiveTotalNodes++;
                
                SetTextAlignment(item);
            }
        }

        public static T FindControl<T>(UIElement parent, Type targetType, string ControlName) where T : FrameworkElement
        {

            if (parent == null) return null;

            if (parent.GetType() == targetType && ((T)parent).Name == ControlName)
            {
                return (T)parent;
            }
            T result = null;
            int count = VisualTreeHelper.GetChildrenCount(parent);
            for (int i = 0; i < count; i++)
            {
                UIElement child = (UIElement)VisualTreeHelper.GetChild(parent, i);

                if (FindControl<T>(child, targetType, ControlName) != null)
                {
                    result = FindControl<T>(child, targetType, ControlName);
                    break;
                }
            }
            return result;
        }

    }
}
